/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __vegetation_OperatorTree_h__
#define __vegetation_OperatorTree_h__

namespace fe
{

/**************************************************************************//**
	@brief Handler to Sim and Draw a Tree

	@ingroup vegetation
*//***************************************************************************/
class FE_DL_EXPORT TreeOp:
	public OperatorSurfaceCommon,
	public Initialize<TreeOp>
{
	public:

									TreeOp(void);
virtual								~TreeOp(void);

		void						initialize(void);

									//* As HandlerI
virtual	void						handle(Record& a_rSignal);

	private:

		SpatialVector				convertY(SpatialVector a_vector);

		SpatialVector				unconvertY(SpatialVector a_vector);

		BWORD						rebuild(sp<SurfaceAccessibleI>&
											a_rspSurfaceAccessible);
		void						replace(sp<SurfaceAccessibleI>&
											a_rspSurfaceAccessible);
		void						regenerate(void);

		String						m_treeName;

		Forest						m_forestRV;
		Plant						m_plantRV;
		sp<Scope>					m_spScope;
		sp<SignalerI>				m_spSignalerI;

		std::vector< sp<HandlerI> >	m_modifierArray;
};

} /* namespace */

#endif /* __vegetation_OperatorTree_h__ */

